unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms,
  StdCtrls, Buttons, Menus, ExtCtrls;

type
  TMainForm = class(TForm)
    TimerTarget: TTimer;
    PnlSpy: TPanel;
    Memo1: TMemo;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Exit1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure PnlSpyMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TimerTargetTimer(Sender: TObject);
    procedure PnlSpyMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Help1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    InMouseDown: Boolean;
  protected

  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

uses
    iMisc, Info;

var
    TargetHandle: HWND = INVALID_HANDLE_VALUE;

//  ===========================================================================
//  RXgN^
//  ---------------------------------------------------------------------------
//  http://www.borland.co.jp/tips/delphi/dh008/
//  http://forum.nifty.com/fdelphi/faq/00289.htm
procedure TMainForm.FormCreate(Sender: TObject);
begin
    //  ^Cgݒ
    Self.Caption := Application.Title + ' - ' + Self.Name;
    //  Lv`łȂ
    InMouseDown := false;
end;

//  ===========================================================================
//  ^[QbgEBhE擾̗Jn
procedure TMainForm.PnlSpyMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Button = mbLeft) then
    begin
        InMouseDown := true;
        Screen.Cursor := CUR_SEEKER;
    end;
end;

//  ===========================================================================
//  łHłH
procedure TMainForm.TimerTargetTimer(Sender: TObject);
var
    WH: HWND;
begin
    if InMouseDown then
    begin
        //  ?
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            InMouseDown := false;
            Screen.Cursor := crDefault;
            Exit;
        end;
        //  }EẌʒũEBhEnh擾
        WH := WindowFromPoint(Mouse.CursorPos);
        //  
        FlashDesktopCanvas(WH, 100);
    end;
end;

//  ===========================================================================
//  ^[QbgEBhE擾̗I
//  ---------------------------------------------------------------------------
//  http://forum.nifty.com/fdelphi/samples/00495.html
procedure TMainForm.PnlSpyMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
    ProcessID{, ThreadID}: integer;
begin
    //  XpCłȂ΃XLbv
    if InMouseDown then
    begin
        //  tO|ăJ[\ɖ߂
        InMouseDown := false;
        Screen.Cursor := crDefault;
        //  }EX̃EBhEnho
        TargetHandle := WindowFromPoint(Mouse.CursorPos);
        if (TargetHandle <> 0) then
        begin
            Memo1.Lines.Clear;
            //  ̃EBhẼvZXID́H
            {ThreadID := }GetWindowThreadProcessId(TargetHandle, @ProcessID);
            //  ł̃W[́H
            PrintModules(ProcessID, Memo1.Lines);
        end;
    end;
end;

//  ===========================================================================
//  AoEg
procedure TMainForm.About1Click(Sender: TObject);
begin
    OpenInfoForm();
end;

//  ===========================================================================
//  wv
procedure TMainForm.Help1Click(Sender: TObject);
var
    s: string;
begin
    s := ''
       + ''#13#10
       + #13#10'}EX{^Ń^[QbgT[hɂȂ܂B'
       + #13#10'^[QbgŃ}EX𗣂Ƃ̃EBhȄ'
       + #13#10'vZXgpĂDLL̈ꗗo͂܂B'
       ;
    InfoOk(s);
end;

procedure TMainForm.Exit1Click(Sender: TObject);
begin
    Exit;
end;

end.

